﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Windows.Forms;
using System.Windows.Media;
using Bots.Grind;
using Styx;
using Styx.Common;
using Styx.CommonBot;
using Styx.Plugins;
using Styx.WoWInternals;
using Styx.WoWInternals.WoWObjects;

namespace Baiterator
{
	public class Baiterator : HBPlugin
	{
		public override string Name { get { return "Baiterator"; } }

		public override string Author { get { return "p1xel8ted"; } }

		public override string ButtonText { get { return "Settings"; } }

		public override bool WantButton { get { return true; } }

		public override Version Version { get { return new Version(1, 0, 8); } }

		private static LocalPlayer Me { get { return StyxWoW.Me; } }

		//This is the list of baits, at the moment its just the WoD baits, because it's all I designed it for. Feel free to add others that you want in the rotation
		private List<uint> baits = new List<uint>(new uint[] {
			110293,	//Abyssal Gulper Eel Bait
			110294,	//Blackwater Whiptail Bait
			110290,	//Blind Lake Sturgeon Bait
			110289,	//Fat Sleeper Bait
			110291,	//Fire Ammonite Bait
			110274,	//Jawless Skulker Bait
			110292 //Sea Scorpion Bait
		});

		//This is the aura for bait once its applied
		private List<uint> baitAuras = new List<uint>(new uint[] {
			158038,	//Abyssal Gulper Eel Bait Aura
			158039,	//Blackwater Whiptail Bait Aura
			158035,	//Blind Lake Sturgeon Bait Aura
			158034,	//Fat Sleeper Bait Aura
			158036,	//Fire Ammonite Bait Aura
			158031,	//Jawless Skulker Bait Aura
			158037 //Sea Scorpion Bait Aura
		});

		//Don't touch this list
		private List<uint> usedBaits = new List<uint>(new uint[] { });

		//Add/remove items in here to delete them/keep them
		private List<uint> deleteList = new List<uint>(new uint[] {
			118380,	//Hightfish Cap
			118393,	//Tentacled Hat
			118381 //Ephemeral Fishing Pole
		});

		//This is the ids of the dweller items, no need to touch anything in here
		private List<uint> dwellerList = new List<uint>(new uint[] {
			116158,	//Lunarfall Carp
			112633 //Frostdeep Minnow
		});

		private List<uint> lootArangList = new List<uint>(new uint[] {
			109167,	//Findle's Loot-A-Rang
			60854 //Loot-A-Rang (Eng Only)
		});

		private const int FPItemId = 118381; //Ephemeral Fishing Pole Item
		private const int bHookItem = 122742; //Bladebone Hook Item
		private const int bHookAura = 182226; //Bladebone Hook Aura
		private const int draenicPoleItem = 116826;	//Draenic Fishing Pole Item

		private frmSettings settings = null;

		private int dwellersSummoned = 0;

		public Baiterator()
		{
			settings = new frmSettings();
		}

		public override void OnButtonPress()
		{
			settings.ShowDialog();
			settings.saveSettings();
			updateStatus();
		}

		//big thanks to Lacrymae - I barely understand this linq stuff.
		private IOrderedEnumerable<WoWUnit> LootableCorpses
		{
			get
			{
				var lootList = ObjectManager.GetObjectsOfType<WoWUnit>(false, false).Where(b => b.Lootable && b.Distance <= 100).OrderBy(l => l.Distance);
				return lootList;
			}
		}

		private void Log(string log, bool error)
		{
			if (error)
			{
				Logging.Write(Colors.Red, Name + " " + Version + " - " + log);
			}
			else
			{
				Logging.Write(Colors.OrangeRed, Name + " " + Version + " - " + log);
			}
		}

		private void updateStatus()
		{
			Log("Summon Dweller: " + settings.SummonCave, false);
			Log("Remove Excess Gear: " + settings.RemoveGear + ", Keep: " + settings.KeepGear.ToString(), false);
			Log("Use Bladebone Hook: " + settings.UseBladebone, false);
			Log("-------------------", false);
			reportUsage();
		}

		private void reportUsage()
		{
			Log("Dwellers Summoned: " + dwellersSummoned, false);
		}

		public override void OnEnable()
		{
			settings.readSettings();
			Log("Enabled", false);
			updateStatus();
			HotkeysManager.Register("Baiterator_Remove", Keys.E, ModifierKeys.Alt, hk => { BaiteratorRemove(); });
			HotkeysManager.Register("Baiterator_Summon", Keys.Q, ModifierKeys.Alt, hk => { BaiteratorSummon(); });
			BotEvents.OnBotStarted += OnBotStarted;
			BotEvents.OnBotStopped += OnBotStopped;
			base.OnEnable();
		}

		private void OnBotStarted(EventArgs args)
		{
			dwellersSummoned = 0;
			Log("Beginning Baiteration Process.", false);
		}

		public override void OnDisable()
		{
			settings.saveSettings();
			Log("Disabled", false);
			HotkeysManager.Unregister("Baiterator_Summon");
			HotkeysManager.Unregister("Baiterator_Remove");
			BotEvents.OnBotStarted -= OnBotStarted;
			BotEvents.OnBotStopped -= OnBotStopped;
			base.OnDisable();
		}

		private void OnBotStopped(EventArgs args)
		{
			Log("Stopping Baiteration Process.", false);
			reportUsage();
		}

		private void BaiteratorSummon()
		{
			if (settings.SummonCave == true)
			{
				settings.SummonCave = false;
				Log("Summon Dweller: False", true);
			}
			else
			{
				settings.SummonCave = true;
				Log("Summon Dweller: True", false);
			}
			settings.saveSettings();
		}

		private void BaiteratorRemove()
		{
			if (settings.RemoveGear == true)
			{
				settings.RemoveGear = false;
				Log("Remove Excess Gear: False", true);
			}
			else
			{
				settings.RemoveGear = true;
				Log("Remove Excess Gear: True", false);
			}
			settings.saveSettings();
		}

		private bool hasFishingPoleEquipped() //check if we have a fishing pole equipped or not
		{
			if (StyxWoW.Me.Inventory.Equipped.MainHand.ItemInfo.WeaponClass == WoWItemWeaponClass.FishingPole)
			{
				return true;
			}
			else
			{
				return false;
			}
		}

		private void checkForDraenicPole() //checks if you have the draenic pole from Nat Pagle, and will use it for the +200 buff
		{
			if (StyxWoW.Me.Inventory.Equipped.MainHand.ItemInfo.Id == draenicPoleItem)
			{
				WoWItem pole = StyxWoW.Me.Inventory.Equipped.MainHand;
				var poleCD = new TimeSpan(0, 0, 0);
				if (pole.CooldownTimeLeft <= poleCD)
				{
					pole.Use();
#pragma warning disable CS0618 // Type or member is obsolete
					StyxWoW.Sleep(1000);
#pragma warning restore CS0618 // Type or member is obsolete
				}
			}
		}

		private WoWItem getDweller()
		{
			foreach (uint i in dwellerList)
			{
				WoWItem dwellar = StyxWoW.Me.BagItems.FirstOrDefault(r => r.Entry == i);
				if (dwellar != null)
				{
					return dwellar;
				}
				continue;
			}
			return null;
		}

		private void throwTheBoomerang()
		{
			var lootTarget = LootableCorpses.FirstOrDefault(); //Thank you to Lacrymae.
			if (getLootArang() != null & lootTarget != null)
			{
				if (lootTarget.Lootable)
				{
					Log("Using " + getLootArang().SafeName + "!", false);
					getLootArang().UseContainerItem();
				}
			}
		}

		private WoWItem getLootArang()
		{
			foreach (uint i in lootArangList)
			{
				WoWItem lootArang = StyxWoW.Me.BagItems.FirstOrDefault(r => r.Entry == i);
				if (lootArang != null)
				{
					var lootCD = new TimeSpan(0, 0, 0);
					if (lootArang.CooldownTimeLeft <= lootCD)
					{
						return lootArang;
					}
				}
				continue;
			}
			return null;
		}

		//check if we are capable of fishing etc
		private bool IfCapable()
		{
			if (!hasFishingPoleEquipped() || Me.Stunned || Me.IsDead || Me.OnTaxi || Me.IsGhost || Me.IsOnTransport || Me.Combat || Me.IsMoving || (Me.Mounted && Me.IsFlying))
			{
				return false;
			}
			else
			{
				return true;
			}
		}

		//check if we have any existing bait auras
		private bool checkAura()
		{
			foreach (int i in baitAuras)
			{
				if (Me.HasAura(i))
				{
					return true;
				}
				else
				{
					continue;
				}
			}
			return false;
		}

		private WoWItem getBait()
		{
			if (usedBaits.Count == baits.Count)
			{
				usedBaits.Clear();
			}
			foreach (uint i in baits)
			{
				WoWItem bait = StyxWoW.Me.BagItems.FirstOrDefault(r => r.Entry == i);
				if (bait == null)
				{
					continue;
				}
				else
				{
					if (settings.dontUse.Contains(i))
					{
						Log("Skipping " + bait.SafeName + " as it is not enabled.", true);
						continue;
					}
					else
					{
						if (!InGarrison())
						{
							return bait;
						}
						else
						{
							if (!usedBaits.Contains(i))
							{
								usedBaits.Add(i);

								return bait;
							}
							else
							{
								continue;
							}
						}
					}
				}
			}
			return null;
		}

		//remove any excess hats/poles. should always leave you with whatever you KEEP_AMOUNT to
		private void removeExcessGear()
		{
			foreach (WoWItem item in StyxWoW.Me.BagItems)
			{
				if (deleteList.Contains(item.ItemInfo.Id))
				{
					while (StyxWoW.Me.GetCarriedItemCount(item.ItemInfo.Id) > settings.KeepGear)
					{
						try
						{
							item.PickUp();
#pragma warning disable CS0618 // Type or member is obsolete
							StyxWoW.Sleep(1000);
							Lua.DoString("DeleteCursorItem()");
							StyxWoW.Sleep(1000);
#pragma warning restore CS0618 // Type or member is obsolete
							Log("Removed extra gear! Keeping " + settings.KeepGear + " of each item!", false);
						}
						catch (Exception e)
						{
							Log("Exception: " + e, true);
							return;
						}
					}
					continue;
				}
				continue;
			}
			return;
		}

		//check if we are in either the horde or alliance garrison
		private bool InGarrison()
		{
			if (Me.ZoneId == 7004 | Me.ZoneId == 7078)
			{
				return true;
			}
			return false;
		}

		private bool isFishing()
		{
			if (hasFishingPoleEquipped() & Me.IsChanneling)
			{
				return true;
			}
			return false;
		}

		private void applyBladebone()
		{
			if (!Me.HasAura(bHookAura))
			{
				WoWItem hook = StyxWoW.Me.BagItems.FirstOrDefault(r => r.Entry == bHookItem);
				if (hook != null)
				{
					Log("Using " + hook.ItemInfo.Name + "!", false);
					hook.Use();
#pragma warning disable CS0618 // Type or member is obsolete
					StyxWoW.Sleep(1000);
#pragma warning restore CS0618 // Type or member is obsolete
				}
			}
		}

		private bool okToSummonCaveDwellar()
		{
			if (InGarrison() & settings.SummonCave & isFishing() & !Me.IsMoving & getDweller() != null)
			{
				return true;
			}
			return false;
		}

		private void killDweller()
		{
#pragma warning disable CS0618 // Type or member is obsolete
			StyxWoW.Sleep(2000);
			LevelBot.BehaviorFlags = BehaviorFlags.All;
			Lua.DoString("TargetNearestEnemy()");
			Log("Summoned Dweller, attempting to initiate combat!", false);
			dwellersSummoned += 1;
			Lua.DoString("AttackTarget()");
#pragma warning restore CS0618 // Type or member is obsolete
		}

		public override void Pulse()
		{
			throwTheBoomerang();
			if (IfCapable())
			{
				if (settings.RemoveGear)
				{
					removeExcessGear();
				}
				if (okToSummonCaveDwellar())
				{
					getDweller().Use();
					killDweller();
				}

				if (!Me.Combat)	//if im not in combat, start fishing
				{
					if (isFishing() & !Me.IsMoving)
					{
						checkForDraenicPole();
						if (settings.UseBladebone)
						{
							applyBladebone();
						}

						if (!checkAura()) //check if we have any active bait buffs
						{
							WoWItem bait = getBait(); //get next available bait
							if (bait != null)
							{
								bait.Use();
								Log("Used " + bait.Name + "!", false);
#pragma warning disable CS0618 // Type or member is obsolete
								StyxWoW.Sleep(1000); //necessary, otherwise plugin was using next bait before aura was applied from previous bait
#pragma warning restore CS0618 // Type or member is obsolete
							}
						}
					}
				}
			}
		}
	}
}