﻿using System;
using System.Collections.Generic;
using System.Windows.Forms;
using System.Windows.Media;
using Styx.Common;

namespace Baiterator
{
	public partial class frmSettings : Form
	{
		private string SettingsFilePath { get; set; }

		public int KeepGear { get; set; }

		public bool RemoveGear { get; set; }

		public bool UseBladebone { get; set; }

		public bool SummonCave { get; set; }

		public bool useAGE { get; private set; }

		public bool useSS { get; private set; }

		public bool useJS { get; private set; }

		public bool useFA { get; private set; }

		public bool useFS { get; private set; }

		public bool useBLS { get; private set; }

		public bool useBW { get; private set; }

		private string name = null;

		private const uint AGE = 110293;
		private const uint BW = 110294;
		private const uint BLS = 110290;
		private const uint FS = 110289;
		private const uint FA = 110291;
		private const uint JS = 110274;
		private const uint SS = 110292;

		public List<uint> dontUse = new List<uint>(new uint[] {
		});

		private Timer time = new Timer();

		public frmSettings()
		{
			InitializeComponent();
			SettingsFilePath = "Settings\\Baiterator.txt";
			readSettings();
		}

		public void saveSettings()
		{
			try
			{
				System.IO.StreamWriter file = new System.IO.StreamWriter(SettingsFilePath);
				file.WriteLine(SummonCave.ToString());
				file.WriteLine(RemoveGear.ToString());
				file.WriteLine(UseBladebone.ToString());
				file.WriteLine(KeepGear.ToString());
				file.WriteLine(useAGE.ToString());
				file.WriteLine(useBW.ToString());
				file.WriteLine(useBLS.ToString());
				file.WriteLine(useFS.ToString());
				file.WriteLine(useFA.ToString());
				file.WriteLine(useJS.ToString());
				file.WriteLine(useSS.ToString());
				file.Close();
				Logging.Write(Colors.OrangeRed, "Baiterator: Settings Updated.");
				readSettings();
				//updateDontUse();
			}
			catch (Exception e)
			{
				Logging.Write(Colors.Red, "Baiterator: Error creating/saving settings.");
				Logging.Write(Colors.Red, "Baiterator: " + e.Message);
			}
		}

		public void readSettings()
		{
			if (System.IO.File.Exists(SettingsFilePath))
			{
				string[] file = System.IO.File.ReadAllLines(SettingsFilePath);
				if (file.Length < 11)
				{
					Logging.Write(Colors.Red, "Baiterator: Incomplete settings, writing defaults. Please re-set your settings.");
					saveSettings();
				}
				else
				{
					chkSummon.Checked = Convert.ToBoolean(file[0]);
					SummonCave = Convert.ToBoolean(file[0]);

					chkRemove.Checked = Convert.ToBoolean(file[1]);
					RemoveGear = Convert.ToBoolean(file[1]);

					chkBladebone.Checked = Convert.ToBoolean(file[2]);
					UseBladebone = Convert.ToBoolean(file[2]);

					txtGear.Text = file[3].ToString();
					KeepGear = Convert.ToInt16(file[3]);

					chkAGE.Checked = Convert.ToBoolean(file[4]);
					useAGE = Convert.ToBoolean(file[4]);

					chkBW.Checked = Convert.ToBoolean(file[5]);
					useBW = Convert.ToBoolean(file[5]);

					chkBLS.Checked = Convert.ToBoolean(file[6]);
					useBLS = Convert.ToBoolean(file[6]);

					chkFS.Checked = Convert.ToBoolean(file[7]);
					useFS = Convert.ToBoolean(file[7]);

					chkFA.Checked = Convert.ToBoolean(file[8]);
					useFA = Convert.ToBoolean(file[8]);

					chkJS.Checked = Convert.ToBoolean(file[9]);
					useJS = Convert.ToBoolean(file[9]);

					chkSS.Checked = Convert.ToBoolean(file[10]);
					useSS = Convert.ToBoolean(file[10]);

					updateDontUse();
				}
			}
			else
			{
				Logging.Write(Colors.Red, "Baiterator: No settings file found, creating one.");
				saveSettings();
			}
		}

		private void btnOK_Click(object sender, EventArgs e)
		{
			saveSettings();
			Close();
		}

		private void chkSummon_CheckedChanged(object sender, EventArgs e)
		{
			SummonCave = chkSummon.Checked;
		}

		private void chkRemove_CheckedChanged(object sender, EventArgs e)
		{
			RemoveGear = chkRemove.Checked;
		}

		private void chkBladebone_CheckedChanged(object sender, EventArgs e)
		{
			UseBladebone = chkBladebone.Checked;
		}

		private void txtGear_TextChanged(object sender, EventArgs e)
		{
			KeepGear = Convert.ToInt16(txtGear.Text);
		}

		private void frmSettings_Load(object sender, EventArgs e)
		{
			chkSummon.Checked = SummonCave;
			chkRemove.Checked = RemoveGear;
			chkBladebone.Checked = UseBladebone;
			chkAGE.Checked = useAGE;
			chkBW.Checked = useBW;
			chkBLS.Checked = useBLS;
			chkFS.Checked = useFS;
			chkFA.Checked = useFA;
			chkJS.Checked = useJS;
			chkSS.Checked = useSS;
			updateDontUse();
		}

		private void updateDontUse()
		{
			if (!chkAGE.Checked) {dontUse.Add(AGE);}
			if (chkAGE.Checked) {dontUse.Remove(AGE);}
			if (!chkBW.Checked) {dontUse.Add(BW);}
			if (chkBW.Checked) {dontUse.Remove(BW);}
			if (!chkBLS.Checked) {dontUse.Add(BLS);}
			if (chkBLS.Checked) {dontUse.Remove(BLS);}
			if (!chkFS.Checked) {dontUse.Add(FS);}
			if (chkFS.Checked) {dontUse.Remove(FS);}
			if (!chkFA.Checked) {dontUse.Add(FA);}
			if (chkFA.Checked) {dontUse.Remove(FA);}
			if (!chkJS.Checked) {dontUse.Add(JS);}
			if (chkJS.Checked) {dontUse.Remove(JS);}
			if (!chkSS.Checked) {dontUse.Add(SS);}
			if (chkSS.Checked) {dontUse.Remove(SS);}
		}

		private void chkAGE_CheckedChanged(object sender, EventArgs e)
		{
			useAGE = chkAGE.Checked;
			updateDontUse();
        }

		private void chkBW_CheckedChanged(object sender, EventArgs e)
		{
			useBW = chkBW.Checked;
			updateDontUse();
        }

		private void chkBLS_CheckedChanged(object sender, EventArgs e)
		{
			useBLS = chkBLS.Checked;
			updateDontUse();
        }

		private void chkFS_CheckedChanged(object sender, EventArgs e)
		{
			useFS = chkFS.Checked;
			updateDontUse();
		}

		private void chkFA_CheckedChanged(object sender, EventArgs e)
		{
			useFA = chkFA.Checked;
			updateDontUse();
		}

		private void chkJS_CheckedChanged(object sender, EventArgs e)
		{
			useJS = chkJS.Checked;
			updateDontUse();
		}

		private void chkSS_CheckedChanged(object sender, EventArgs e)
		{
			useSS = chkSS.Checked;
			updateDontUse();
		}

		private void frmSettings_FormClosed(object sender, FormClosedEventArgs e)
		{
			saveSettings();
		}
	}
}